<?php
// Copyright 1999-2017. Plesk International GmbH. All rights reserved.
namespace Atf\ComposerAtfVersions\Command;

use Atf\ComposerAtfVersions\SubComposer;
use Composer\Command\BaseCommand;

abstract class SubComposerCommandBase extends BaseCommand
{
    protected static $versionsPath = '/tests/atf/versions';

    /**
     * @return SubComposer
     */
    protected function getSubComposer()
    {
        $path = $this->getVersionsPath();
        $path = trim($path, '\//');

        $appDir = getcwd();
        $directories = glob($appDir . '/' . $path . '/*', GLOB_ONLYDIR)
            ?: [];

        return new SubComposer($directories);
    }

    /**
     * @return string
     */
    protected function getVersionsPath()
    {
        $extra = $this->getComposer()->getPackage()->getExtra();
        if (isset($extra['atf-versions']['path'])
            && is_string($extra['atf-versions']['path'])) {
            return $extra['atf-versions']['path'];
        }

        return static::$versionsPath;
    }
}
