<?php
// Copyright 1999-2017. Plesk International GmbH. All rights reserved.

namespace Atf\ComposerAtfVersions;

class EnvHolder
{
    private $var;
    private $orig;
    private $current;

    public function __construct($var)
    {
        $this->var = $var;
        $this->orig = $this->current = getenv($var);
    }

    /**
     * @param string|null $value
     * @param bool $force
     * @throws \Exception
     */
    public function set($value, $force = false)
    {
        if (is_null($this->current)) {
            $this->current = getenv($this->var);
        }

        if (is_null($value)) {
            $value = false;
        }

        if ($value === $this->current && !$force) {
            return;
        }

        $setting = ($value === false)
            ? $this->var
            : "{$this->var}={$value}";
        if (!putenv($setting)) {
            throw new \Exception("Failed to set environment variable {$this->var}={$value}");
        }
        $this->current = $value;
    }

    public function revert($force = false)
    {
        $this->set($this->orig, $force);
    }
}
