<?php
// Copyright 1999-2017. Plesk International GmbH. All rights reserved.

namespace Atf\ComposerAtfVersions;

class EnvHolderSet
{
    /**
     * @var EnvHolder[]
     */
    private $holders = [];

    public function with($var, $value)
    {
        $holder = array_key_exists($var, $this->holders)
            ? $this->holders[$var]
            : ($this->holders[$var] = new EnvHolder($var));
        $holder->set($value);

        return $this;
    }

    public function without($var)
    {
        return $this->with($var, null);
    }

    public function rollback()
    {
        foreach ($this->holders as $holder) {
            $holder->revert();
        }
    }
}
